//	fobOxLCD16x1ΉCu
//	wt]xH쎺	http://jsdiy.web.fc2.com
/*
ygz
p̃vWFNgɁulcd16x1tool.cvulcd16x1tool.hvB
p̃t@Cňȉ̂悤ɋLqB

#include "lcd16x1tool.h"
void func()
{
	ComInit();
	_delay_ms(100);
	LcdCls();
	LcdPutU8(123);
	LcdPutI8(-45);
	LcdPutChar('a');
}

yXVz
2013/09/20	v1.00	LCD16x1type3ɑΉ
*/

#include <avr/io.h>
#include <util/delay.h>
#include "lcd16x1tool.h"

enum	E_DATA_TYPE
{						//'A'`'P'ȊO̕Œ`
	CMD_CLS				= '*',
	CMD_SET_POS			= 'p',
	DATA_END			= '\n',
	//10i\L
	DATA_TYPE_INT8		= 'i',
	DATA_TYPE_UINT8		= 'u',
	DATA_TYPE_INT16		= 'n',
	DATA_TYPE_UINT16	= 't',
	//16i\L
	DATA_TYPE_BYTE		= 'b',
	DATA_TYPE_WORD		= 'w',
	//
	DATA_TYPE_CHAR		= 'c',
	DATA_TYPE_STR		= 's'
};

#if _ATmega48
void	ComInit()
{
	UBRR0 = F_CPU / 16 / BAUDRATE - 1;
	
	//UMSEL01/00 = 00:񓯊
	//UPM01/00 = 00:peBȂ, 10:peB, 11:peB
	//USBS0 = 0:Xgbvrbg1, 1:Xgbvrbg2
	//UCSR0B:UCSZ02-UCSR0C:UCSZ01/00 = 011:f[^8rbg
	UCSR0B	= (0 << RXEN0) | (1 << TXEN0) | (0b0 << UCSZ02);
	UCSR0C	= (0b00 << UMSEL00) | (0b00 << UPM00) | (0 << USBS0) | (0b11 << UCSZ00);
}

static	void WriteReg(uint8_t n)
{
	loop_until_bit_is_set(UCSR0A, UDRE0);	//Mobt@̋󂫑҂
	UDR0 = n;
}
#endif	//_ATmega48

#if	_ATtiny2313
void	ComInit()
{
	UBRRH	= 0;
	UBRRL	= F_CPU / 16 / BAUDRATE - 1;
	
	//UMSEL= 0:񓯊
	//UPM1/0 = 00:peBȂ, 10:peB, 11:peB
	//USBS = 0:Xgbvrbg1, 1:Xgbvrbg2
	//UCSRB:UCSZ2-UCSRC:UCSZ1/0 = 011:f[^8rbg
	UCSRB	= (0 << RXEN) | (1 << TXEN) | (0b0 << UCSZ2);
	UCSRC	= (0 << UMSEL) | (0b00 << UPM0) | (0 << USBS) | (0b11 << UCSZ0);
}

static void	WriteReg(uint8_t n)
{
	loop_until_bit_is_set(UCSRA, UDRE);	//Mobt@̋󂫑҂
	UDR = n;
}
#endif	//_ATtiny2313

void	LcdCls()
{
	WriteReg(CMD_CLS);
	WriteReg(DATA_END);
	_delay_ms(10);	//LCDW[ClearDisplayR}h͊ɎԂ̂Ŏԑ҂Kv
}

void	LcdPutChar(char c)	//1o͂
{
	WriteReg(DATA_TYPE_CHAR);
	WriteReg(c);
	WriteReg(DATA_END);
}

void	LcdPutStr(const char* s)	//o͂i16܂Łj
{
	uint8_t count = 0;
	WriteReg(DATA_TYPE_STR);
	while (*s != '\0' && count++ < 16)
	{
		WriteReg(*s);
		s++;
	}	
	WriteReg(DATA_END);
}

static void	SendNumData(uint8_t type, uint16_t data, uint8_t byteLen)
{
	uint8_t i;
	byteLen *= 2;
	
	WriteReg(type);
	for (i = 0; i < byteLen; i++)
	{
		WriteReg('A' + (uint8_t)(data & 0x000F));
		data >>= 4;
	}			
	WriteReg(DATA_END);
}

void	LcdSetPos(uint8_t x)	//\̈ʒu x=0`15
{
	SendNumData(CMD_SET_POS, x, 1);
}

void	LcdPutU8(uint8_t n)	//10i0`255o͂
{
	SendNumData(DATA_TYPE_UINT8, n, 1);
}

void	LcdPutI8(int8_t n)	//10i-128`127o͂
{
	if (n < 0)
	{
		LcdPutChar('-');
		LcdPutU8(-n);
	}
	else
	{
		LcdPutU8(n);
	}
}

void	LcdPutByte(uint8_t b)	//16i00`FFo͂
{
	SendNumData(DATA_TYPE_BYTE, b, 1);
}

void	LcdPutU16(uint16_t n)	//10i0`65535o͂
{
	SendNumData(DATA_TYPE_UINT16, n, 2);
}

void	LcdPutI16(int16_t n)	//10i-32768`32767o͂
{
	if (n < 0)
	{
		LcdPutChar('-');
		LcdPutU16(-n);
	}
	else
	{
		LcdPutU16(n);
	}
}

void	LcdPutWord(uint16_t w)	//16i0000`FFFFo͂
{
	SendNumData(DATA_TYPE_WORD, w, 2);
}
